# DOES NOT WORK

 # `x >= 0 /\ y >= 0 /\ z >= 0 /\     
 #   x^4 + y^4 + z^4 = 27 /\ c >= 0 /\ c^2 = 3
 #   ==> x + y + z <= 3 * c`;;

load 'solve_sos_equation.sage'
relative_threshold=1

indeterminates=['x', 'y', 'z', 'c']
polynomial_ring=PolynomialRing(QQ, indeterminates)
  
conseq=polynomial_ring('3*c-(x+y+z)')

rhs_polynomial=polynomial_ring(0) # conseq

pdeg_max=3
positive_monomial_list=[polynomial_ring('x')^a * polynomial_ring('y')^b * polynomial_ring('z')^c * polynomial_ring('c')^d for a in range(pdeg_max) for b in range(pdeg_max-a) for c in range(pdeg_max-a-b) for d in range(pdeg_max-a-b-c)]

positive_polynomials1=[polynomial_ring('x'), polynomial_ring('y'), polynomial_ring('z'), polynomial_ring('c')]
positive_polynomials=[positive_polynomials1[0]^c0 * positive_polynomials1[1]^c1 * positive_polynomials1[2]^c2 * positive_polynomials1[3]^c3 for c0 in range(2) for c1 in range(2) for c2 in range(2) for c3 in range(2)] 
positive_polynomials.append(-conseq)
positive_monomial_lists=[positive_monomial_list for p in positive_polynomials]

equality_polynomials=[polynomial_ring('x^4 + y^4 + z^4 - 27'), polynomial_ring('c^2-3')]
edeg_max=14
equality_monomial_list=[polynomial_ring('x')^a * polynomial_ring('y')^b * polynomial_ring('z')^c * polynomial_ring('c')^d for a in range(edeg_max) for b in range(edeg_max-a) for c in range(edeg_max-a-b) for d in range(edeg_max-a-b-c)]
equality_monomial_lists=[equality_monomial_list for p in equality_polynomials]


solution = solve_sos_equation_sos(polynomial_ring, positive_polynomials, positive_monomial_lists, equality_polynomials, equality_monomial_lists, rhs_polynomial)

def apply_sos_solution(pblocks, eblocks):
  assert(len(pblocks) == len(positive_monomial_lists))
  assert(len(pblocks) == len(positive_polynomials))
  assert(len(eblocks) == len(equality_monomial_lists))
  assert(len(eblocks) == len(equality_polynomials))

  total = polynomial_ring(0)
  for (sos, poly, monomials) in zip(pblocks, positive_polynomials, positive_monomial_lists):
    total += poly * apply_sos(sos, monomials)
  for (lin, poly, monomials) in zip(eblocks, equality_polynomials, equality_monomial_lists):
    total += poly * (lin * vector(monomials))
  return total

if solution == ():
  print 'NO SOLUTION'
else:
  (pblocks, eblocks) = solution
  assert(apply_sos_solution(pblocks, eblocks)==rhs_polynomial)
  print 'SOLUTION'
  print 'RHS'
  print rhs_polynomial
  for i in xrange(len(positive_polynomials)):
    print 'POSITIVE POLYNOMIAL', i
    print positive_polynomials[i]
    print 'sos polynomial'
    print apply_sos(pblocks[i], positive_monomial_lists[i])
    print 'summands'
    for coeff, sos in pblocks[i]:
      print coeff, "*(", sum([a*b for a, b in zip(sos, positive_monomial_lists[i])]), ")^2"
  for i in xrange(len(equality_polynomials)):
    print 'ZERO POLYNOMIAL', i
    print equality_polynomials[i]
    print 'factor polynomial'
    print eblocks[i] * vector(equality_monomial_lists[i])
