load 'linear_algebra.sage'

kernel_scaling = 1e14
relative_threshold1 = 3.
relative_threshold2 = 3.

m=Matrix(QQ,
[[                 1,                 22,  317518848/2624123],
 [                22, 1270075602/2624123,               2662],
 [ 317518848/2624123,               2662,              14641]])

scaling = kernel_scaling / m.norm('frob')
zmat = block_matrix([round_matrix(m*scaling,sparse=false), identity_matrix(m.nrows())], 1, 2)
reduced=zmat.LLL()
thresh1 = vector(RDF,reduced.row(0)[m.ncols():reduced.ncols()]).norm()*relative_threshold1
thresh2 = vector(RDF,reduced.row(0)).norm()*relative_threshold2
